> For the complete documentation index, see [llms.txt](https://docs.validere.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.validere.com/guides/api/data.md).

# Data API

## Overview

The Data API is a critical component of the Validere platform, designed to facilitate the seamless transfer of data from clients to our platform. Through the Public API, clients can push data directly or utilize secure file transfer methods. This section outlines the key routes available for data submission.

{% hint style="info" %}
`https://api.validere.io/platform/v1`
{% endhint %}

## Required parameters

Three parameters are required to successfully ingest data from client data sources using Validere’s push connectors.

### Client ID

Validere provides a `client_id` for each client in order to authorize access to their datasets.

**Note**: There can be many `client_id`s per Validere client.

### Dataset ID

Validere provides a `dataset_id` for each dataset that clients intend to ingest into the platform.

### Dataset Schema

In order to ensure successful ingestion into Validere’s data platform, clients are required to provide a sample dataset schema representing the expected shape and format of the data. This schema is leveraged to validate data that is pushed to Validere’s data platform, ensuring quality of client submitted data.

Validere's data engineering and technical services team can assist with defining a schema that satisfies the use case and data integration as needed.

We utilize the [JSON schema](https://json-schema.org/) format to define the schema of incoming data validation.

An example of a schema that would need to be registered prior to ingestion:

```json
{
    "$schema": "http://json-schema.org/draft-06/schema#",
    "examples": [
        {
            "date": "2023-05-04",
            "well-name": "ExampleWell 10 #1",
            "flow_bbl_d": 7.5,
        }
    ],
    "properties": {
        "date": {
            "type": "string"
        },
        "well-name": {
            "type": "string"
        },
        "flow_bbl_d": {
            "type": "number"
        }
    },
    "required": [
        "date",
        "well-name",
        "flow_bbl_d"
    ]
}
```

## Endpoints

### Push JSON Data

* **Endpoint**: `POST /data/json`
* **Description**: Allows clients to push data in JSON format directly to the Validere platform.
* **Request Body**:
  * A JSON object containing the data to be pushed.
* **Response**: Confirmation of successful data submission or details of any errors encountered.

### Get S3 Presigned File Upload URL

* **Endpoint**: `GET /data/file_upload_url`
* **Description**: Provides clients with a presigned URL for secure file uploads to an S3 bucket.
* **Request**: The file name and content type.
* **Response**: The presigned URL for uploading the file.

### Upload Data to Presigned URL

* **Description**: After obtaining the presigned URL from the `/data/file_upload_url` endpoint, clients can upload their file directly to the provided S3 URL.
* **Method**: PUT
* **Request**: The file data is sent as the request body to the presigned URL.
* **Response**: S3 server response, typically a confirmation of successful upload.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.validere.com/guides/api/data.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
